#include "core.h"

Core::Core(QObject *parent):
  QObject(parent)
  {
  #ifdef CORE_USE_THREAD
  m_worker=new Thread(this);
  #else
  m_worker=new Worker(this);
  #endif
  connect(m_worker,SIGNAL(result(quint32)),this,SLOT(workerResult(quint32)));
  QTimer::singleShot(0,this,SLOT(run()));
  }

void Core::run(void)
  {
  QTextStream stream(stdout);
  quint32 a=12;
  quint32 b=8;

  stream<< "A: " << a << " B: " << b << "\n";
  stream.flush();

  m_worker->average(a,b);
  }


void Core::workerResult(quint32 value)
  {
  QTextStream stream(stdout);

  stream<<"Result value: "<< value <<"\n\n";
  stream.flush();

  emit quit();
  }
