#include "thread.h"

Thread::Thread(QObject *parent):
  AbstractWorker(parent)
  {
  m_thread=new QThread();
  m_worker=new Worker();

  m_worker->moveToThread(m_thread);

  connect(m_thread,SIGNAL(finished()),m_worker,SLOT(deleteLater()));
  connect(m_worker,SIGNAL(result(quint32)),this,SIGNAL(result(quint32)),Qt::QueuedConnection);
  m_thread->start();
  }

Thread::~Thread()
  {
  m_thread->quit();
  m_thread->wait();
  m_thread->deleteLater();
  }

void Thread::average(quint32 a,quint32 b)
  {
  QMetaObject::invokeMethod(m_worker,"average",Qt::QueuedConnection,Q_ARG(quint32,a),Q_ARG(quint32,b));
  }
